--
-- $Id: create.sql,v 1.5 2001/09/28 17:46:16 voeckler Exp voeckler $
--

create sequence SEQ_XFORM;
create sequence SEQ_PARAM;
create sequence SEQ_DDATA;

create table TRANSFORMATION (
    XID          integer default nextval('SEQ_XFORM'),
    ENVIRONMENT  varchar(2048),
    EXECUTABLE   varchar(1024) not null,

    constraint PK_XFORM primary key(XID)
);

create table PARAMETER (
    PID          integer default nextval('SEQ_PARAM'),
    -- In our case, inheritence can be collapsed into the PARAMETER class,
    -- because typeof(FILE.URN) == typeof(STRING.value).
    VALUE        varchar(1024), -- logical filename or cmdline parameter

    constraint PK_PARAMETER primary key(PID)
);

create table REPLICA_CATALOG (
    -- A 1:N relation can be collapsed into the N entity class.
    PID          integer,	       -- logical filename id
    URI          varchar(1024),	       -- physical filename

    constraint FK_RC_PARAMETER foreign key(PID) references PARAMETER
);

create table DERIVED (
    XID          integer,
    PID          integer,
    DDID	 integer,
    -- '-' non-file argument, 'i' input lfn, 'o' output lfn
    -- 'I' stdin, 'O' stdout, 'E' stderr
    FLAG         char default '-',
    -- stdio args do not have a position...
    POS          integer,

    constraint FK_DERIVED_FUNCTION foreign key(XID) references TRANSFORMATION,
    constraint FK_DERIVED_PARAMETER foreign key(PID) references PARAMETER,
    constraint PK_DERIVED primary key(PID,DDID,POS) -- removed xid := f(ddid)
);

create index I_DERIVED_XID on DERIVED(XID);
create index I_DERIVED_PID on DERIVED(PID);
create index I_DERIVED_DID on DERIVED(DDID);
